/*
 Program    : 4 bitlik Hamming Kodlamasi Simulasyonu
 Hazirlayan : Ahmet Bingul, Gaziantep MYO

 Not : Baslangicta alicinin algiladigi bitler vericideki ile ayni kabul
       ediliyor. Sonra alcidaki bitlerden rastgele bir tanesi bozuluyor.
       Hamming Kodlamasi yntemi kullanilarak bozuk bitin yeri tespit
       edilip duzeltiliyor.
*/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

/* Mantik kapilari */

char INV(char x){
 if ( x=='0' ) {return '1';}
 if ( x=='1' ) {return '0';}
}

char OR(char x,char y){
 if ( x=='0' && y=='0' ) return '0';
 else return '1';
}

char AND(char x,char y){
 if(x=='1' && y=='1' ) return '1';
 else return '0';
}


char XOR(char x,char y){
 if( x != y ) return '1';
 else return '0';
}

char XNOR(char x,char y){
 return INV( XOR(x,y) );
}

/*Ana program */

main(){

char I[4]={'1','0','1','0'}; /* Gonderilen bilgi bitleri */
char J[4]={'1','0','1','0'}; /* Alicida algilanan (simdilik hepsi dogru) */
char CI[4],CJ[4],F[4],II[4],Kod;
int  i,bit;

 randomize();           /* 0-3 arasinda rastgele sayi uretiliyor */
 bit =  random(4); /* ve bit degiskenine bu sayi aktariliyor... */

  J[bit] = INV(J[bit]); /* algilanan bitlerden 'bit' posizyonundaki
			    bit bozuluyor. Dolayisiyla algilanan bitler
			    hatali oluyor. */
 clrscr();

 CI[0] = XOR( I[0] , XOR(I[1],I[3]) ); /* Gonderilen kontrol bitleri */
 CI[1] = XOR( I[0] , XOR(I[2],I[3]) );
 CI[2] = XOR( I[1] , XOR(I[2],I[3]) );

 CJ[0] = XOR( J[0] , XOR(J[1],J[3]) ); /* Alicida algilanan konrol bitleri */
 CJ[1] = XOR( J[0] , XOR(J[2],J[3]) );
 CJ[2] = XOR( J[1] , XOR(J[2],J[3]) );


 for(i=0;i<3;i++){ F[i]  = XNOR( CI[i],CJ[i] ); }  /*  Gonderilen ve algilanan
						      bitlerin mukayesesi.
						      esitse 1 degilse 0
						      gonder.
						   */

 Kod = AND( F[0],AND(F[1],F[2]) );                 /* Eger kod hatasiz ise
						     tum F'ler 1 ve bunlarin
						     ANDlenmesi 1
						   */

 II[0] = XNOR( OR(F[0],F[1])          , J[0] );   /* Duzeltilmis hali */
 II[1] = XNOR( OR(F[0],F[2])          , J[1] );
 II[2] = XNOR( OR(F[1],F[2])          , J[2] );
 II[3] = XNOR( OR(F[0],OR(F[1],F[2]) ), J[3] );

 /* Sonuclar Ekrana */

 puts("4 bitlik 'Hamming Kodlamasi Simulasyonu'\n");
 printf("Bilgi Bitleri     : ");
 for(i=0;i<4;i++){ printf("%c",I[i]); }
 printf("\n");

 printf("Alicida alginanan : ");
 for(i=0;i<4;i++){ printf("%c",J[i]);  }
 if(Kod == '1') {
  printf(" <-- Kod Hatasi tespit edilmedi.\n");
 }
 else printf(" <-- Kod Hatali Algilandi !...\n");

 printf("Duzeltilmis hali  : ");
 for(i=0;i<4;i++){ printf("%c",II[i]); };printf("\n");

return 0;
}
/* EOF - Ahmet Bingul / 29.03.2001 */